/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8d Professional

Project : Behzad MT88E43 based CallerID System .
Version : 1.0
Date    : 2007/02/21
Author  : Behzad khazama                            
Company : www.khazama.com                            
Comments: This Project is only for educational purpose and NOT for 
          comercial usage . use this with own risk and without any warranty 
          I have used a very simple CID detection algoritm in this code and you must complete it yourself
          Please let me know any bug's or your suggestions. write your comment's around this project in 
          my sites forum's www.khazama.com

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

// Declare your global variables here
#define LATCH_OE PORTD.0
#define FSK_EN   PORTD.1
#define RINGING  PIND.3
#define LCD_EN   PORTD.4
#define FSK_DISABLE 0
#define FSK_ENABLE  1
#define LCD_DISABLE 1
#define LCD_ENABLE  0

void init(void);
unsigned char BUF[255];   
unsigned char b=0 ;       // buffer counter

// External Interrupt 0 service routine  
// this int will call when a data is ready to read from the LATCH output
interrupt [EXT_INT0] void ext_int0_isr(void)
{
 unsigned char i,j;
 LCD_EN=LCD_DISABLE;       // disable LCD
 i=DDRB;j=PORTB;           // save current DDR & PORT value's
 DDRB=0x00;PORTB=0xff;     // change port dir to input
 LATCH_OE=0;               // enalbe latch output's
 #asm("nop\nop\nop\nop\nop") // wait a bit
 BUF[b++]=PINB;            // read data
 if(b>254)b=0;             // prevent from overflow or over pointing
 LATCH_OE=1;               // disable latch output's
 DDRB=i;PORTB=j;           // restore DDR & PORT value's
 LCD_EN=LCD_ENABLE;        // enable LCD
}

//==================================================
//
void main(void)
{
unsigned char i=0,j=0;
init();
LATCH_OE=1;           // disable latch output's
FSK_EN=FSK_DISABLE;   // disable 8843 FSK demedolation
LCD_EN=LCD_ENABLE;
lcd_init(16);  
lcd_clear();
lcd_putsf("Wait for Ring");  
while(1){
        for(i=0;i<254;i++)BUF[i]=0; // fill the buffer with zero
        b=0;
        while(RINGING);  // wait for first ring 
        #asm("sei")
        FSK_EN=FSK_ENABLE;
        lcd_clear();
        lcd_putsf("First ring");  
        while(~RINGING);

        delay_ms(4000);                

        #asm("cli")
        FSK_EN=FSK_DISABLE;
        lcd_clear();
        if(BUF[1]==0x55){ 
         for(i=1;i<60;i++){
          if(BUF[i]!=0x55)break; // 0x55 is chanle seizure
         }
         i+=2;
         j=i+BUF[i]+1;  // BUF[i] contain data LEN.
                      // i.e: at my town, SABZEVAR-IRAN it was 20(0x14) 
                      // this byte recived after a 0x04 witch I think it mean as a message type indicator.          
         for(i=i+1;i<j;i++)
          lcd_putchar(BUF[i]);
        }  
        else{
         lcd_putsf("UnKnow CID Data!");  
        } // end if(BUF[1]=0x55)
        delay_ms(7000); 
   }  // end while(1)
}  // end main

//==================================================
//
void init(void){
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=0 State3=P State2=P State1=0 State0=1 
PORTD=0x0D;
DDRD=0x13;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GICR|=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

}