/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8d Professional

Project : Behzad MT88E43 based CallerID System .
Version : 1.0
Date    : 2007/02/21
Author  : Behzad khazama                            
Company : www.khazama.com                            
Comments: This Project is only for educational purpose and NOT for 
          comercial usage . use this with own risk and without any warranty 
          I have used a very simple CID detection algoritm in this code and you must complete it yourself
          Please let me know any bug's or your suggestions. write your comment's around this project in 
          my sites forum's www.khazama.com

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib



// Declare your global variables here

void init(void);
unsigned char BUF[255];   
unsigned char b=0 ;       // buffer counter

// External Interrupt 0 service routine  
// this int will call when a data is ready to read from the LATCH output
interrupt [2] void ext_int0_isr(void)
{
 unsigned char i,j;
 PORTD.4=1;       // disable LCD
 i=DDRB;j=PORTB;           // save current DDR & PORT value's
 DDRB=0x00;PORTB=0xff;     // change port dir to input
 PORTD.0=0;               // enalbe latch output's
 #asm("nop\nop\nop\nop\nop") // wait a bit
 BUF[b++]=PINB;            // read data
 if(b>254)b=0;             // prevent from overflow or over pointing
 PORTD.0=1;               // disable latch output's
 DDRB=i;PORTB=j;           // restore DDR & PORT value's
 PORTD.4=0;        // enable LCD
}

//==================================================
//
void main(void)
{
unsigned char i=0,j=0;
init();
PORTD.0=1;           // disable latch output's
PORTD.1=0;   // disable 8843 FSK demedolation
PORTD.4=0;
lcd_init(16);  
lcd_clear();
lcd_putsf("Wait for Ring");  
while(1){
        for(i=0;i<254;i++)BUF[i]=0; // fill the buffer with zero
        b=0;
        while(PIND.3);  // wait for first ring 
        #asm("sei")
        PORTD.1=1;
        lcd_clear();
        lcd_putsf("First ring");  
        while(~PIND.3);

        delay_ms(4000);                

        #asm("cli")
        PORTD.1=0;
        lcd_clear();
        if(BUF[1]==0x55){ 
         for(i=1;i<60;i++){
          if(BUF[i]!=0x55)break; // 0x55 is chanle seizure
         }
         i+=2;
         j=i+BUF[i]+1;  // BUF[i] contain data LEN.
                      // i.e: at my town, SABZEVAR-IRAN it was 20(0x14) 
                      // this byte recived after a 0x04 witch I think it mean as a message type indicator.          
         for(i=i+1;i<j;i++)
          lcd_putchar(BUF[i]);
        }  
        else{
         lcd_putsf("UnKnow CID Data!");  
        } // end if(BUF[1]=0x55)
        delay_ms(7000); 
   }  // end while(1)
}  // end main

//==================================================
//
void init(void){
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=0 State3=P State2=P State1=0 State0=1 
PORTD=0x0D;
DDRD=0x13;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GICR|=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

}
